# Harmony Files Directory

Welcome to the Harmony Files Directory. Here, you can manage alterations to the
preprocessed data that Harmonize returns to your `$variables` array and subsequently
your Twig templates.

This folder should already contain files you can use and/or base yourself on. The functionality
is self-explanatory as you view these files. To add to this, documentation has been added as well
to aid you in your preprocessing endeavours.

You will find that this folder works quite similarly to the `templates` folder in your theme.

## Configurations

Configurations for Harmony Files can be found in the website's admin interface. You can visit
`/admin/config/harmonize/harmony-files` to adjust some settings.

Mainly, you can change the file extension of the files that will be loaded. By default, the module will load all
files with the `.harmony` extension.

## Pre-Existing Alterations

Please note that the example files found here certainly do work on your website. These out of the box alterations serve
two purposes:

* To show examples of what can be done.
* To provide some baseline alterations that make data organization cleaner out of the box.

While some pre-existing alterations exist, a large majority of the files here contain no specific alterations and serve as
example files to guide developers in the right direction. They can safely be removed with no worries.

## Suggestions

Below is a rough list of suggestions for file names.

**Note:** File suggestions are being revised in a later version of Harmonize to further resemble the way
template suggestions work. For now, we must make do with the list below.

For all suggestions below, these are the full suggestions possible. All later parts can be omitted for shorter
and wider targeting.

### Entities

`entity.[ENTITY_TYPE_ID].[BUNDLE].[VIEW_MODE].[ID].[REVISION_ID].[LANG]`

### Entity Fields

`field.[FIELD_TYPE].[FIELD_MACHINE_NAME].[ENTITY_TYPE_ID].[BUNDLE].[ENTITY_ID].[LANG]`

## Functions.php

The `functions.php` file can be used to declare utility functions that are re-usable across all
harmony files.

There are examples of this in the files as well.

## Services & Dependency Injection

_Coming soon!_
